/*
 * ASE1508.asm
 *
 *  Created: 16/12/2015 18.25.13
 *  Author: Roberto Roncella
 *  Compito del 17/11/2015
 *  Realizzare una subroutine per il microcontrollore AVR XMEGA256A3BU, 
 *  che valuta il prodotto scalare di 2 vettori costituiti ciascuno 
 *  da 32 elementi da 1 byte (senza segno) e posti in memoria rispettivamente 
 *  agli indirizzi 0x3000 e 0x3100. 
 *  Il risultato, che deve essere valutato senza errori, 
 *  deve essere posto nelle locazioni consecutive a partire dalla 0x3200 (LSByte first)
 */ 
test: //sezione di test della subroutine
 rcall scalar_product //predisporre la memoria con il debugger
 rjmp test

scalar_product:
 push R0 //salva i registri usati
 push R1
 push R2
 push R16
 push R17
 push R18
 push XL
 push XH
 push YL
 push YH
 ldi XH,high(a01)
 ldi XL,low(a01)
 ldi YH,high(b01)
 ldi YL,low(b01)
 clr R20
 clr R21
 clr R22
 clr R2
 ldi R18,32 //contatore
 loop:
  ld R16,X+
  ld R17,Y+
  mul R16,R17
  add R20,R0
  add R21,R1
  add R22,R2 //il risultato sta su 3 bytes (max:32*255^2)
  dec R18
  brne loop
 ldi XH,high(c01) //salva il risultato
 ldi XL,low(c01)
 st X+,R20
 st X+,R21
 st X+,R22
 pop YH //salva i registri usati
 pop YL
 pop XH
 pop XL
 pop R18
 pop R17
 pop R16
 pop R2
 pop R1
 pop R0
 ret

.dseg
.org 0x3000
a01: .byte 1
a02: .byte 1
a03: .byte 1
a04: .byte 1
a05: .byte 1
a06: .byte 1
a07: .byte 1
a08: .byte 1
a09: .byte 1
a10: .byte 1
a11: .byte 1
a12: .byte 1
a13: .byte 1
a14: .byte 1
a15: .byte 1
a16: .byte 1
a17: .byte 1
a18: .byte 1
a19: .byte 1
a20: .byte 1
a21: .byte 1
a22: .byte 1
a23: .byte 1
a24: .byte 1
a25: .byte 1
a26: .byte 1
a27: .byte 1
a28: .byte 1
a29: .byte 1
a30: .byte 1
a31: .byte 1
a32: .byte 1
.org 0x3100
b01: .byte 1
b02: .byte 1
b03: .byte 1
b04: .byte 1
b05: .byte 1
b06: .byte 1
b07: .byte 1
b08: .byte 1
b09: .byte 1
b10: .byte 1
b11: .byte 1
b12: .byte 1
b13: .byte 1
b14: .byte 1
b15: .byte 1
b16: .byte 1
b17: .byte 1
b18: .byte 1
b19: .byte 1
b20: .byte 1
b21: .byte 1
b22: .byte 1
b23: .byte 1
b24: .byte 1
b25: .byte 1
b26: .byte 1
b27: .byte 1
b28: .byte 1
b29: .byte 1
b30: .byte 1
b31: .byte 1
b32: .byte 1
.org 0x3200
c01: .byte 1 //LSB del risultato
c02: .byte 1
c03: .byte 1
